﻿init python:
    from copy import copy
    def get_key():
        if event in pygame.event.get():
            if event.type == pygame.KEYDOWN:
                msg.msg("key down")
            if event.type == pygame.KEYUP:
                msg.msg("key up")
    def load_map(tilemap):
        map = []
        f = open(renpy.loader.transfn(tilemap),"r")
        for line in f:
            line = line.strip()
            divided = line.split(",")
            listed = [[x, []] for x in divided]
            map.append(listed)
        f.close()
        return map
    def load_tiles(img, size):
        tiles = []
        for i in range(8):
            for ii in range(8):
                tiles.append(Crop((ii*size,i*size,size,size), img))
        return tiles

    class tile:
        def __init__(self, image, type):
            self.image = image
            self.type = type

    class level_class:
        def __init__(self, name, size, map, level = 0,
            objects = [], exits = [], npc = [], enemies = []):
            self.name = name
            self.size = size
            self.set = load_tiles(map[0], size)
            self.map = load_map(map[1])
            self.level = level
            self.steps = 0
            self.exits = exits
            self.npc = []
            for i in npc:
                i[0].x , i[0].y = i[1], i[2]
                self.npc.append(i[0])
            self.collisions = []
            for i in range(-1, 24):
                self.collisions.append(str(i))
            if objects:
                for i in objects:
                    self.map[i[1]][i[0]][1].append(i[2])
            self.enemies = []
            for i in enemies:
                if len(i) == 4:
                    self.spawn(i[0], i[1], i[2], i[3])
                else:
                    self.spawn(i[0], i[1], i[2])
        def has_object(self, object):
            for i in self.map:
                for j in i:
                    if len(j[1]):
                        for k in j[1]:
                            if k == object:
                                return True
            else:
                return False
        def collide(self, actor, direction, x = 0, y = 0, alpha = 1):
            if actor:
                x = actor.x
                y = actor.y
                if direction == "up":
                    y -= 1
                elif direction == "left":
                    x -= 1
                elif direction == "down":
                    y += 1
                elif direction == "right":
                    x += 1
            if y < 0 or y > len(self.map)-1:
                msg.msg("down")
                return "wall"
            if hero.y == y:
                if hero.x == x:
                    return "player"
            for i in self.enemies:
                if i.y == y:
                    if i.x == x:
                        if not i.stat == "dead":
                            return "enemy", i
            # for i in self.enemies:
            #     if i.y == y:
            #         if i.x == x:
            #             if i.stat == "dead":
            #                 return "dead enemy", i
            for i in self.npc:
                if i.y == y:
                    if i.x == x:
                        return "npc", i
            if self.map[y][x][0] in self.collisions:
                return "wall"
            else:
                return False
        def spawn(self, enemy, x = None, y = None, hp = None, food = None, alpha = 0):
            enemy.alpha = alpha
            if not x:
                for i in range(100):
                    x = renpy.random.randint(0, len(self.map[0])-1)
                    y = renpy.random.randint(0, len(self.map)-1)
                    if not self.collide(None, None, x, y):
                        break
                else:
                    x = None

            if x:
                enemy = copy(enemy)
                enemy.x = x
                enemy.y = y
                if hp != None:
                    enemy.hp = hp
                if food != None:
                    enemy.food = food
                else:
                    enemy.food = renpy.random.randint(2, 100)
                self.enemies.append(enemy)
        def kill_enemy(self):
            for i in self.enemies:
                i.stat = "dead"
        def reveal_enemies(self):
            for i in self.enemies:
                i.alpha = 1
        def take(self):
            if len(self.map[hero.y][hero.x][1]):
                it = self.map[hero.y][hero.x][1].pop()
                hero.got(True, it, 1)

        def move(self, direction):
            if renpy.get_screen("say") or renpy.get_screen("choice"):
                return
            if not hero.stat == "dead":
                hero.direction = direction
                hero.busy = 10
                hero.locked = True
                hero.stat = "walk"

                coll = self.collide(hero, direction)
                if coll:
                    if coll[0] == "npc":
                        self.talk(coll[1])
                    elif coll[0] == "enemy":
                        self.attack(hero, coll[1])
                else:
                    self.go(hero, direction)
                    x = hero.x
                    y = hero.y
                    for i in self.exits:
                        if i[0] == x and i[1] == y:
                            Show("level_change", g = self, exit = i)()
                    
                    self.steps += 1
                    if self.steps > 30:
                        if self.level > 0:
                            self.spawn(renpy.random.choice(all_enemies))
                        self.steps = 0
                    elif self.steps == 1:
                        self.reveal_enemies()
                    
                    if hero.hp < hero.max_hp and hero.food > 0:
                        hero.hp += 1
                        hero.food -= 1
                    if hero.food < 1:
                        hero.hp -= 1

                self.enemies_turn()

        def enter_level(self, exit):
            Hide("level")()
            level = eval(exit[2])

            for i in level.exits:
                if i[3] == exit[3]:
                    doorway = i
                    hero.x, hero.y = i[0], i[1]
                    break
            Show("level", g = level, direction = doorway[4])()
            # hero.x, hero.y = level.exits[exit[3]][0], level.exits[exit[3]][1]
            t = []
            for i in level.enemies:
                if not i.stat == "dead":
                    t.append(i)
            level.enemies = t
            for i in level.enemies:
                if i.hp < 1:
                    i.direction = renpy.random.choice(["left", "right"])
                    i.stat = "dead"
        def go(self, actor, direction):
            if direction == "up":
                actor.y -= 1
            elif direction == "left":
                actor.x -= 1
            elif direction == "down":
                actor.y += 1
            elif direction == "right":
                actor.x += 1
        def talk(self, actor):
            actor.face(hero)
            Call(actor.name.lower())()
        def attack(self, attacker, target):
            global talking_to
            attacker.stat = "attack"
            if attacker == hero:
                talking_to = target
            else:
                talking_to = attacker
            crit = renpy.random.randint(-2, 2)
            damage = (attacker.total_attack + crit) - target.armor
            if damage < 1:
                damage = 1
            target.hp -= damage
            if target.hp < 1:
                target.stat = "dead"
                if not target == hero: # Drop loot
                    loot = drop_more(target.table, renpy.random.randint(0, 4))
                    for i in loot:
                        self.map[target.y][target.x][1].append(i)

        def walk(self, person, direction):
            person.direction = direction
            person.busy = 10
            person.locked = True
            person.stat = "walk"
            
            coll =  self.collide(person, direction)
            if not coll or coll[0] == "dead enemy":
                self.go(person, direction)

        def enemies_turn(self):
            for i in self.enemies:
                if not i.stat == "dead":
                    direction = i.face(hero, False, True)
                    coll = self.collide(i, direction)
                    if not coll or coll[0] == "dead enemy":
                        self.walk(i, direction)
                    elif coll == "player":
                        i.alpha = 1
                        i.direction = direction
                        self.attack(i, hero)
                    elif coll:
                        direction = renpy.random.choice(["up", "left", "down", "right"])
                        self.walk(i, direction)
transform level_change_fade:
    alpha 0
    ease .2 alpha 1
    pause .5
    ease .2 alpha 0
screen level_change(g, exit):
    # modal True
    zorder -1
    add "loading" at level_change_fade
    timer .2 action Function(g.enter_level, exit = exit)
    timer .9 action Hide("level_change")
screen level(g, direction):
    zorder -2

    timer .5 action Function(g.move, direction)
    default scale = 2.0
    hbox:
        align .5,.0 spacing 10
        bar value ScreenVariableValue("scale", 3.0, offset=1.0) xysize 500,40
        button:
            ysize 40 xpadding 10
            text "reset" align .5,.5
            action SetScreenVariable("scale", 2.0)
    frame:
        ysize 860 yalign .0 background None
        fixed:
            fit_first True
            at zoom(scale)
            vbox:
                spacing 0
                for ii in g.map:
                    hbox:
                        spacing 0
                        for i in ii:
                            if i[0] == "-1":
                                frame:
                                    background None xysize(g.size,g.size)
                            else:
                                frame:
                                    background g.set[int(i[0])]
                                    xysize(g.size,g.size)
                                    if len(i[1]):
                                        add i[1][0].icon align .5,.5 at zoom(.5)
            for i in g.npc:
                frame:
                    xysize(g.size, g.size) background None at player_move(i.x*g.size, i.y*g.size) align .0,.0
                    add "{} {} {}".format(i.name, i.direction, i.stat) align(.5,.5) yoffset -8
            for i in g.enemies:
                frame:
                    xysize(g.size, g.size) background None at player_move(i.x*g.size, i.y*g.size) align .0,.0
                    add "{} {} {}".format(i.name, i.direction, i.stat) align(.5,.5) yoffset -8 at player_alpha(i.alpha)

            frame:
                xysize(g.size, g.size) background None at player_move(hero.x*g.size, hero.y*g.size) align .0,.0
                add "{} {} {}".format(hero.name, hero.direction, hero.stat) align(.5,.5) yoffset -8
    default enter_pause = True
    timer .8 action SetScreenVariable("enter_pause", False)
    if hero.busy > 0:
        timer .06 repeat True action Function(hero.tick)
    if hero.locked:
        timer .32 repeat True action Function(hero.unlock)
        key "w" action NullAction()
        key "a" action NullAction()
        key "s" action NullAction()
        key "d" action NullAction()
    elif not enter_pause:
        key "w" action Function(g.move, "up")
        key "a" action Function(g.move, "left")
        key "s" action Function(g.move, "down")
        key "d" action Function(g.move, "right")
        key "repeat_w" action Function(g.move, "up")
        key "repeat_a" action Function(g.move, "left")
        key "repeat_s" action Function(g.move, "down")
        key "repeat_d" action Function(g.move, "right")
    key "e" action Function(g.take)
    vbox:
        align .0,.0
        text "{}({})   {},{}    {}".format(g.name, g.level, hero.x, hero.y, g.steps) color "#ffd"

    # drag:
    #     align .99,.4
    #     frame:
    #         vbox:
    #             spacing 10
    #             text "Tests"
    #             button:
    #                 text "Spawn"
    #                 action Function(g.spawn, renpy.random.choice(all_enemies), alpha = 1)
    #             button:
    #                 text "Face"
    #                 action Function(thora.face, hero)
    #             button:
    #                 text "Face way"
    #                 action Function(thora.face, hero, True)
    #             button:
    #                 text "reveal"
    #                 action Function(g.reveal_enemies)
    #             button:
    #                 text "Kill all"
    #                 action Function(g.kill_enemy)

transform player_move(x, y):
    linear .45 xpos x ypos y
transform player_alpha(a = 1):
    alpha a
